; /////////////////////////////////////////////////////////////////////////
; BuildSub.Asm Library Frequency Chart Builder
; 2000 Cygnus X-1 Technologies
;
; You are not allowed to distribute a modified source file nor 
; the binary. Any changes must be for personal use only and be reported to:
; Julien Solignac <x1cygnus@online.fr>
; #########################################################################

;      -=-=-=-=-=-=-==-=-=-=-=-=-=-
; -==-==- Frequency Transcriber -==-==-
;      -=-=-=-=-=-=-==-=-=-=-=-=-=-
; This Will Scan The Fast Frequency Chart & Build
; The Framed Structure.

BuildSub:
	LD	HL, FastChart
	LD	BC, 0FF00h
	XOR	A
	LD	(CatalogedBytes), A

BuildSubLp:
	INC	B
	INC	C
	RET	Z

BuildSub_Continue:
	LD	E, (HL)
	INC	HL
	LD	D, (HL)
	INC	HL

	LD	A, E
	OR	D
	JR	Z, BuildSubLp

	PUSH	DE
	PUSH	BC

	EXX

	CALL	AddStructure

; 0      2       3       5   6   7
; /------------------------------\
; | Freq | Value | Ptr 1 | Ptr 2 |
; \------------------------------/
;                            *We Are Here*
;        *& Go Here* --> - 04h

	LD	DE, 0000h - 0004h
	ADD	HL, DE

	POP	AF
	LD	(HL), A
	DEC	HL
	POP	DE
	LD	(HL), D
	DEC	HL
	LD	(HL), E

	LD	HL, CatalogedBytes
	INC	(HL)

	EXX
	JR	BuildSubLp
