; /////////////////////////////////////////////////////////////////////////
; PackSub.Asm Library File Packer
; 2000 Cygnus X-1 Technologies
;
; You are not allowed to distribute a modified source file nor 
; the binary. Any changes must be for personal use only and be reported to:
; Julien Solignac <x1cygnus@online.fr>
; #########################################################################

PackSub:
	LD	HL, (DestinationHeader)
	LD	DE, (Location)
	LD	BC, (FileSize)
	PUSH	BC
; Preserve FileSize
	LDIR

	EX	DE, HL
; HL = End Of Location

	PUSH	IX
	POP	DE

	PUSH	HL
	LD	HL, SafeBytes
	ADD	HL, DE
	EX	DE, HL
	POP	HL
; Safe Margin

	PUSH	DE
; Preserve # Of Bytes

	OR	A
	SBC	HL, DE

	Invoke(DeleteMem)
	CALL	FileSub_UpdateLocation

	POP	DE
; Restore # Of Bytes
	POP	HL
; Restore File Size

	OR	A
	SBC	HL, DE
	EX	DE, HL
	LD	HL, (Location)
	DEC	HL
	LD	(HL), D
	DEC	HL
	LD	(HL), E
	RET
