; /////////////////////////////////////////////////////////////////////////
; AddSub.Asm Library Add Empty Structure Routine For XAlgo
; 2000 Cygnus X-1 Technologies
;
; You are not allowed to distribute a modified source file nor 
; the binary. Any changes must be for personal use only and be reported to:
; Julien Solignac <x1cygnus@online.fr>
; #########################################################################

;      -=-=-=-=-=-=-=-=-=-=-=-=-
; -==-==- Add Empty Structure  -==-==-
;      -=-=-=-=-=-=-=-=-=-=-=-=-
; This Will Add An Empty Structure
; To The Beginning Of The Table


; This Must Be Defined If Debugging
;#IfNDef	XDebug
;#Define Debug
;#EndIf

#IfDef Debug
.NOLIST
#DEFINE equ .equ
#DEFINE EQU .equ
#DEFINE end .end
#INCLUDE "TI83ASM.INC"
#INCLUDE "TOKENS.INC"
#INCLUDE "CYGNUS.INC"

.LIST
.ORG	9327h

#EndIf

AddStructure:
#IfNDef	Debug
	LD	HL, (StrucTableTotalEntrys)
#Else
	LD	HL, (EndOfStructure - Structure) / 07h
#EndIf

	INC	HL

#IfNDef	Debug
	LD	(StrucTableTotalEntrys), HL
	LD	DE, (Structure)
#Else
	LD	DE, Structure
#EndIf

	PUSH	DE
	PUSH	DE

	LD	HL, 0007h
	PUSH	HL

	Invoke(InsertMem)
	POP	HL

#IfNDef	Debug
	LD	DE, (StrucTableTotalEnd)
#Else
	LD	DE, EndOfStructure
#EndIf

	ADD	HL, DE

#IfNDef	Debug
	LD	(StrucTableTotalEnd), HL
#EndIf

	POP	HL
	POP	DE
	INC	DE
	LD	(HL), 00h
	LD	BC, 0006h
	LDIR

#IfNDef	Debug
	RET
#Else
	CALL	_DISPHL
	CALL	_GETKEY
	JP	4062h
#EndIf


#IfDef	Debug
	.DB	"Begin", 0FFh
Structure:
	.DW	0000h
	.DB	01h
	.DW	0000h, 0000h

	.DW	0000h
	.DB	02h
	.DW	0000h, 0000h
	
	.DW	0000h
	.DB	02h
	.DW	0000h, 0000h
EndOfStructure:

END
.END
#EndIf
