; This Must Be Defined If Debugging
;#Define	Debug

#IfDef	Debug
.NOLIST
#DEFINE equ .equ
#DEFINE EQU .equ
#DEFINE end .end
#INCLUDE "TI83ASM.INC"
#INCLUDE "TOKENS.INC"
#INCLUDE "CYGNUS.INC"

DatArea		EQU	StatVars
XSortBuffer	EQU	DatArea + 0000h

.LIST
.ORG	9327h
#EndIf

XSort:
#IfNDef	Debug
	LD	HL, (Structure)
#Else
	LD	HL, Structure
#EndIf

	LD	E, (HL)
	INC	HL
	LD	D, (HL)

	LD	BC, 0006h

XSortLp:
	ADD	HL, BC

	LD	A, (HL)
	INC	HL
	PUSH	HL
	LD	H, (HL)
	LD	L, A

	Invoke(_CPHLDE)
	JR	C, FoundEntry
	JR	Z, FoundEntry

	POP	HL
	JP	XSortLp

FoundEntry:
#IfNDef	Debug
	LD	HL, (Structure)
#Else
	LD	HL, Structure
#EndIf

	PUSH	HL
; Preserve Structure
	LD	DE, XSortBuffer
	INC	BC
	LDIR

	POP	DE
; Restore Structure

	POP	HL
	LD	BC, 0000h - 0008h
	ADD	HL, BC
	PUSH	HL
; Refresh Entry

	OR	A
; Carry Is Set As FoundEntry Is Taken Only On NC
	SBC	HL, DE
	JR	NZ, OrderNormal
	LD	HL, 0007h

	POP	BC
	PUSH	HL
	ADD	HL, BC
	EX	(SP), HL

OrderNormal:
	PUSH	HL
	POP	BC

	LD	HL, 0007h
	PUSH	HL
; Store Value
	ADD	HL, DE
	LDIR

	POP	BC
; Restore Value
	POP	DE
; Restore Entry
	LD	HL, XSortBuffer
	LDIR

#IfDef	Debug
	CALL	_GETKEY
	RET
#EndIf

#IfDef	Debug
	.DB	"Begin", 0FFh
Structure:
	.DW	000Fh
	.DB	0Fh
	.DW	0000h, 0000h
	
	.DW	000Ah
	.DB	0Ah
	.DW	0000h, 0000h

	.DW	0008h
	.DB	08h
	.DW	0000h, 0000h

	.DW	0007h
	.DB	07h
	.DW	0000h, 0000h

	.DW	0005h
	.DB	05h
	.DW	0000h, 0000h

	.DW	0004h
	.DB	04h
	.DW	0000h, 0000h
.END
END
#EndIf
